<?

/*
 * Bast Castle firmware (YouTube Processor)
 *
 * Copyright (c) 2013, Sekator500 <sekator500@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


$ctx = stream_context_create(array('http' => array('timeout' => 10, 'header' => "User-Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:9.0.1) Gecko/20100101 Firefox/9.0.1")));

switch ($_GET['method']) {

	case "comments":
	
		$id = $_GET['feed'];
  		$jsn =  json_decode(@file_get_contents("http://gdata.youtube.com/feeds/api/$id&fields=entry(author(name),content,updated)&alt=json", 0, $ctx));		
		
		for ($i = 0,$c = 0; $i < count($jsn->feed->entry); $i++) {
		
		
				echo date("d-m-Y H:i:s", strtotime($jsn->feed->entry[$i]->updated->{'$t'})) ."\t".
				$jsn->feed->entry[$i]->author[0]->name->{'$t'} ."\t".
				urlencode(preg_replace('/\x{EF}\x{BB}\x{BF}/','',$jsn->feed->entry[$i]->content->{'$t'})) ."\n";
			
		
		}		
		
	
	break;

	case "data":
	

		$id = $_GET['feed'];
  		$jsn =  json_decode(@file_get_contents("http://gdata.youtube.com/feeds/api/$id&fields=entry(author(name),yt:statistics,gd:rating,media:group(yt:videoid,media:description,media:title,yt:uploaded,yt:duration,media:thumbnail(@url)))&alt=json", 0, $ctx));
  		
		for ($i = 0,$c = 0; $i < count($jsn->feed->entry); $i++) {
		
			if ($jsn->feed->entry[$i]->{'media$group'}->{'yt$duration'}->seconds > 0) {
		
				echo $jsn->feed->entry[$i]->{'media$group'}->{'yt$videoid'}->{'$t'} ."\t".
				$jsn->feed->entry[$i]->{'media$group'}->{'media$title'}->{'$t'} ."\t".
				$jsn->feed->entry[$i]->{'media$group'}->{'yt$uploaded'}->{'$t'} ."\t".
				$jsn->feed->entry[$i]->{'media$group'}->{'yt$duration'}->seconds ."\t".
				$jsn->feed->entry[$i]->{'media$group'}->{'media$thumbnail'}[2]->url ."\t".
				$jsn->feed->entry[$i]->{'gd$rating'}->average ."\t".
				($jsn->feed->entry[$i]->{'yt$statistics'}->viewCount == "" ? 0 : $jsn->feed->entry[$i]->{'yt$statistics'}->viewCount) ."\t".
				$jsn->feed->entry[$i]->{'gd$rating'}->numRaters ."\t".
				$jsn->feed->entry[$i]->author[0]->name->{'$t'} ."\t".
				urlencode($jsn->feed->entry[$i]->{'media$group'}->{'media$description'}->{'$t'}) ."\n";
			
			}
		
		}
		
	
	break;
	
	case "playlist":
	
	
		$id = $_GET['feed'];
  		$jsn =  json_decode(@file_get_contents("http://gdata.youtube.com/feeds/api/$id&fields=entry(author(name),published,title,yt:playlistId,media:group(yt:duration,media:thumbnail(@url)))&alt=json", 0, $ctx));

		for ($i = 0,$c = 0; $i < count($jsn->feed->entry); $i++) {
		

			echo $jsn->feed->entry[$i]->{'yt$playlistId'}->{'$t'} ."\t".
			$jsn->feed->entry[$i]->title->{'$t'} ."\t".
			$jsn->feed->entry[$i]->published->{'$t'} ."\t".
			$jsn->feed->entry[$i]->{'media$group'}->{'yt$duration'}->seconds ."\t".
			$jsn->feed->entry[$i]->{'media$group'}->{'media$thumbnail'}[2]->url ."\t0\t0\t0\t". $jsn->feed->entry[$i]->author[0]->name->{'$t'} . "\n";

		
		}	
	
	
	break;


	case "video":
	
		$id = $_GET['video_id'];
		
		if (shell_exec("cat /proc/cpuinfo | grep FPU") != NULL) {
			$params = " autoReconnect fileCache=/tmp/videoCachefile cacheSize=16"; //1186
		} else {
			$params = " autoReconnect"; //1185,1073
		}
		
		$data = @file_get_contents("https://www.youtube.com/get_video_info?video_id=$id&el=detailpage&ps=xl&eurl=http://s.ytimg.com/yts/swfbin/express_beta-vfl5N0h48.swf&hl=en_US", 0, $ctx);		

		parse_str($data,$ex);
		$data = explode(',',$ex['url_encoded_fmt_stream_map']); 
		foreach($data as $item){ 
		
			parse_str($item,$ex);
			switch ($ex['itag']) {
			
				case "34": //360p
				case "22": //720p
				case "37": //1080p
				case "35": //480p
				case "18": //360p
				
					echo $ex['itag'] . "\t". $ex['url'] . "&signature=" . $ex['sig'] . "&keepalive=yes$params\n";
				
				break;
				
			}
		
		}
		
	
	break;
	
	
	case "image":
	
		Header("Content-type: image/jpeg");
		echo @file_get_contents($_GET['url'], 0, $ctx);
	
	break;

}





?>